/* Copyright (C) 2005 Martin Koegler
 * Copyright (C) 2015-2019 m-privacy GmbH
 * 
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 * USA.
 */

#include <unistd.h>

#include <rfb/SSecurityStack.h>
#include <rfb/SSecurityMulti.h>
#include <rfb/LogWriter.h>

using namespace rfb;

static LogWriter vlog("SecurityStack");

SSecurityStack::SSecurityStack(SConnection* sc, int Type,
				SSecurity* s0, SSecurity* s1, SSecurity* s2)
  : SSecurity(sc), state(0), state0(s0), state1(s1), state2(s2), type(Type)
{
}

SSecurityStack::~SSecurityStack()
{
  if (state2)
    delete state2;
  if (state1)
    delete state1;
  if (state0)
    delete state0;
}

bool SSecurityStack::processMsg()
{
  bool res = true;

  if (state == 0) {
    if (state0)
      res = state0->processMsg();
    if (!res)
      return res;
    state++;
  }

  if (state == 1) {
    if (state1) {
      res = state1->processMsg();
      unlink(FLAG_FILE);
      unlink(INITIALURL_FILE);
      unlink(PULSEAUDIO_UNIX_SOCKET);
      unlink(NOAUDIO_FILE);
      unlink(NOPRINT_FILE);
      if (res && state0)
        state0->postAuth();
    }
    if (!res)
      return res;
    state++;
  }

  if (state == 2) {
    if (state2) {
      res = state2->processMsg();
      unlink(INITIALURL_FILE);
      if (res && state1)
        state1->postAuth();
    }
    if (!res)
      return res;
    else if (state2)
      state2->postAuth();
    state++;
  }

  return res;
}

const char* SSecurityStack::getUserName() const
{
  const char* c = 0;

  if (state2 && !c)
    c = state2->getUserName();
  if (state1 && !c)
    c = state1->getUserName();
  if (state0 && !c)
    c = state0->getUserName();

  return c;
}

SConnection::AccessRights SSecurityStack::getAccessRights() const
{
  SConnection::AccessRights accessRights;

  if (!state0 && !state1)
    return SSecurity::getAccessRights();

  accessRights = SConnection::AccessFull;

  if (state0)
    accessRights &= state0->getAccessRights();
  if (state1)
    accessRights &= state1->getAccessRights();

  return accessRights;
}
